<!-- 发起邀请 -->
<template>
  <div style="font-size: 14px;">
    <div class="mt-5 color-777">将下面的公共邀请链接通过微信、QQ等任何方式发给同事，即可点击加入公司。请注意，用户同意后将自动加入到团队中，您需确保添加到的同事为同一公司招聘人员</div>
    <div class="mt-5 d-flex align-center">
      <div class="mr-5 shareUrlTxtBox">
        <span v-if="code">{{ shareUrlTxt }}</span>
        <span v-else class="color-666">点击刷新生成邀请链接</span>
      </div>
      <!-- <v-btn color="primary" class="mr-3" @click="copy()">{{ $t('common.copy') }}</v-btn> -->
      <v-btn color="green" variant="outlined" @click="refresh()">{{ $t('common.refresh') }}</v-btn>
    </div>
    <div class="mt-5 color-777">请复制链接进行分享，链接{{ day }}天内有效</div>
  </div>
</template>

<script setup>
import Snackbar from '@/plugins/snackbar'
import {
  enterpriseInviteGenerateCode,
  enterpriseInviteGetCode,
  enterpriseInviteRefresh,
} from '@/api/recruit/enterprise/enterpriseInvite.js'
import { computed, ref } from 'vue'
defineOptions({name: 'groupAccount-component-invite'})
const props = defineProps({
  inviteType: {
    type: [Number, String],
    default: 0 // 类型 (0 邀请同事 | 1 邀请子公司),示例值(2)
  }
})
const inviteType = props.inviteType - 0

const day = 30
const code = ref('')
const accessUrl = import.meta.env.VITE_ACCESS_BASE_URL
const shareUrlTxt = computed(() => {
  const url = inviteType ? 'enterpriseInvite' : 'invite'
  return accessUrl + `/${url}?code=${code.value}`
})

// 基本逻辑：是否已有邀请码？->
//          有：直接调用获取邀请码
//          没有：有生成邀请码标识->获取邀请码
// 刷新： 先调用刷新邀请码接口再执行上面逻辑

// 获取邀请码
const getCode = async (type) => {
  try {
    const data = await enterpriseInviteGetCode({ type: props.inviteType })
    if (!data) getGenerateCode()
    code.value = data
    if (type === 'refresh') Snackbar.success('刷新成功')
  } catch (err) {
    console.err(err)
  }
}
getCode()

// 生成邀请码标识
const getGenerateCode = async (type) => {
  try {
    const data = await enterpriseInviteGenerateCode({ type: props.inviteType, expireDay: 30 })
    if (!data) Snackbar.error('生成邀请码标识失败')
    getCode(type)
  } catch (err) {
    console.err(err)
  }
}

// 刷新邀请码
const refresh = async () => {
  try {
    await enterpriseInviteRefresh(code.value)
    getCode('refresh')
  } catch (err) {
    console.err(err)
  }
}

// const copy = async () => {
//   try {
//     await navigator.clipboard.writeText(shareUrlTxt.value)
//     Snackbar.success('复制成功')
//   } catch (err) {
//     Snackbar.error('复制失败，请手动复制。')
//   }
// }

</script>
<style lang="scss" scoped>
.shareUrlTxtBox {
  line-height: 30px;
  background-color: #f0f0f0;
  // border-radius: 5px;
  padding: 6px 16px;
  min-width: 600px;
}
</style>
